Whamcloud - gitweb
LU-5710 all: second batch of corrected typos and grammar errors
[fs/lustre-release.git] / lustre / tests / sanity-hsm.sh
old mode 100644 (file)
new mode 100755 (executable)
index 8687a61..0ee67b1
@@ -11,12 +11,9 @@ SRCDIR=$(dirname $0)
 export PATH=$PWD/$SRCDIR:$SRCDIR:$PWD/$SRCDIR/utils:$PATH:/sbin:/usr/sbin
 
 ONLY=${ONLY:-"$*"}
-# bug number for skipped test:
+# bug number for skipped test:    LU-3815
+ALWAYS_EXCEPT="$SANITY_HSM_EXCEPT 34 35 36"
 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
-# skip test cases failed before landing - Jinshan
-
-ALWAYS_EXCEPT="$SANITY_HSM_EXCEPT 31a 34 35 36"
-ALWAYS_EXCEPT="$ALWAYS_EXCEPT 200 201 221 223a 223b 225"
 
 LUSTRE=${LUSTRE:-$(cd $(dirname $0)/..; echo $PWD)}
 
@@ -27,13 +24,12 @@ init_logging
 
 MULTIOP=${MULTIOP:-multiop}
 OPENFILE=${OPENFILE:-openfile}
-MCREATE=${MCREATE:-mcreate}
 MOUNT_2=${MOUNT_2:-"yes"}
 FAIL_ON_ERROR=false
 
-if [[ $MDSCOUNT -ge 2 ]]; then
-       skip_env "Only run with single MDT for now" && exit
-fi
+# script only handles up to 10 MDTs (because of MDT_PREFIX)
+[ $MDSCOUNT -gt 9 ] &&
+       error "script cannot handle more than 9 MDTs, please fix" && exit
 
 check_and_setup_lustre
 
@@ -91,15 +87,22 @@ init_agt_vars() {
 
        export HSMTOOL=${HSMTOOL:-"lhsmtool_posix"}
        export HSMTOOL_VERBOSE=${HSMTOOL_VERBOSE:-""}
+       export HSMTOOL_UPDATE_INTERVAL=${HSMTOOL_UPDATE_INTERVAL:=""}
+       export HSMTOOL_EVENT_FIFO=${HSMTOOL_EVENT_FIFO:=""}
+       export HSMTOOL_TESTDIR
        export HSMTOOL_BASE=$(basename "$HSMTOOL" | cut -f1 -d" ")
        HSM_ARCHIVE=$(copytool_device $SINGLEAGT)
        HSM_ARCHIVE_NUMBER=2
 
-       MDT_PARAM="mdt.$FSNAME-MDT0000"
-       HSM_PARAM="$MDT_PARAM.hsm"
+       # The test only support up to 10 MDTs
+       MDT_PREFIX="mdt.$FSNAME-MDT000"
+       HSM_PARAM="${MDT_PREFIX}0.hsm"
 
        # archive is purged at copytool setup
        HSM_ARCHIVE_PURGE=true
+
+       # Don't allow copytool error upon start/setup
+       HSMTOOL_NOERROR=false
 }
 
 # Get the backend root path for the given agent facet.
@@ -112,11 +115,28 @@ copytool_device() {
 
 # Stop copytool and unregister an existing changelog user.
 cleanup() {
+       copytool_monitor_cleanup
        copytool_cleanup
        changelog_cleanup
        cdt_set_sanity_policy
 }
 
+get_mdt_devices() {
+       local mdtno
+       # get MDT device for each mdc
+       for mdtno in $(seq 1 $MDSCOUNT); do
+               local idx=$(($mdtno - 1))
+               MDT[$idx]=$($LCTL get_param -n \
+                       mdc.$FSNAME-MDT000${idx}-mdc-*.mds_server_uuid |
+                       awk '{gsub(/_UUID/,""); print $1}' | head -n1)
+       done
+}
+
+search_copytools() {
+       local agents=${1:-$(facet_active_host $SINGLEAGT)}
+       do_nodesv $agents "pgrep -x $HSMTOOL_BASE"
+}
+
 search_and_kill_copytool() {
        local agents=${1:-$(facet_active_host $SINGLEAGT)}
 
@@ -124,16 +144,73 @@ search_and_kill_copytool() {
        do_nodesv $agents "killall -q $HSMTOOL_BASE" || true
 }
 
+copytool_monitor_setup() {
+       local facet=${1:-$SINGLEAGT}
+       local agent=$(facet_active_host $facet)
+
+       local cmd="mktemp --tmpdir=/tmp -d ${TESTSUITE}.${TESTNAME}.XXXX"
+       local test_dir=$(do_node $agent "$cmd") ||
+               error "Failed to create tempdir on $agent"
+       export HSMTOOL_MONITOR_DIR=$test_dir
+
+       # Create the fifo and a monitor (cat dies when copytool dies)
+       do_node $agent "mkfifo -m 0644 $test_dir/fifo" ||
+               error "failed to create copytool fifo on $agent"
+       cmd="cat $test_dir/fifo > $test_dir/events &"
+       cmd+=" echo \\\$! > $test_dir/monitor_pid"
+
+       if [[ $PDSH == *Rmrsh* ]]; then
+               # This is required for pdsh -Rmrsh and its handling of remote
+               # shells.
+               # Regular ssh and pdsh -Rssh work fine without this
+               # backgrounded subshell nonsense.
+               (do_node $agent "$cmd") &
+               export HSMTOOL_MONITOR_PDSH=$!
+
+               # Slightly racy, but just making a best-effort to catch obvious
+               # problems.
+               sleep 1
+               ps -p $HSMTOOL_MONITOR_PDSH >&- ||
+                       error "Failed to start copytool monitor on $agent"
+       else
+               do_node $agent "$cmd"
+               if [ $? != 0 ]; then
+                       error "Failed to start copytool monitor on $agent"
+               fi
+       fi
+}
+
+copytool_monitor_cleanup() {
+       local facet=${1:-$SINGLEAGT}
+       local agent=$(facet_active_host $facet)
+
+       if [ -n "$HSMTOOL_MONITOR_DIR" ]; then
+               # Should die when the copytool dies, but just in case.
+               local cmd="kill \\\$(cat $HSMTOOL_MONITOR_DIR/monitor_pid)"
+               cmd+=" 2>/dev/null || true"
+               do_node $agent "$cmd"
+               do_node $agent "rm -fr $HSMTOOL_MONITOR_DIR"
+               export HSMTOOL_MONITOR_DIR=
+       fi
+
+       # The pdsh should die on its own when the monitor dies. Just
+       # in case, though, try to clean up to avoid any cruft.
+       if [ -n "$HSMTOOL_MONITOR_PDSH" ]; then
+               kill $HSMTOOL_MONITOR_PDSH 2>/dev/null
+               export HSMTOOL_MONITOR_PDSH=
+       fi
+}
+
 copytool_setup() {
        local facet=${1:-$SINGLEAGT}
        local lustre_mntpnt=${2:-$MOUNT}
        local arc_id=$3
-       local hsm_root=$(copytool_device $facet)
+       local hsm_root=${4:-$(copytool_device $facet)}
        local agent=$(facet_active_host $facet)
 
        if [[ -z "$arc_id" ]] &&
                do_facet $facet "pkill -CONT -x $HSMTOOL_BASE"; then
-                       echo "Wakeup copytool $facet on $agent"
+                       echo "Only wakeup running copytool $facet on $agent"
                        return 0
        fi
 
@@ -148,6 +225,10 @@ copytool_setup() {
        # independent of hardware
        local cmd="$HSMTOOL $HSMTOOL_VERBOSE --daemon --hsm-root $hsm_root"
        [[ -z "$arc_id" ]] || cmd+=" --archive $arc_id"
+       [[ -z "$HSMTOOL_UPDATE_INTERVAL" ]] ||
+               cmd+=" --update-interval $HSMTOOL_UPDATE_INTERVAL"
+       [[ -z "$HSMTOOL_EVENT_FIFO" ]] ||
+               cmd+=" --event-fifo $HSMTOOL_EVENT_FIFO"
        cmd+=" --bandwidth 1 $lustre_mntpnt"
 
        # Redirect the standard output and error to a log file which
@@ -156,18 +237,78 @@ copytool_setup() {
        [[ -z "$TESTNAME" ]] || prefix=$prefix.$TESTNAME
        local copytool_log=$prefix.copytool${arc_id}_log.$agent.log
 
-       do_facet $facet "$cmd < /dev/null > $copytool_log 2>&1" ||
-               error "start copytool $facet on $agent failed"
+       do_facet $facet "$cmd < /dev/null > $copytool_log 2>&1"
+       if [[ $? !=  0 ]]; then
+               [[ $HSMTOOL_NOERROR == true ]] ||
+                       error "start copytool $facet on $agent failed"
+               echo "start copytool $facet on $agent failed"
+       fi
+
        trap cleanup EXIT
 }
 
+get_copytool_event_log() {
+       local facet=${1:-$SINGLEAGT}
+       local agent=$(facet_active_host $facet)
+
+       [ -z "$HSMTOOL_MONITOR_DIR" ] &&
+               error "Can't get event log: No monitor directory!"
+
+       do_node $agent "cat $HSMTOOL_MONITOR_DIR/events" ||
+               error "Could not collect event log from $agent"
+}
+
 copytool_cleanup() {
        trap - EXIT
-       local agents=${1:-$(facet_active_host $SINGLEAGT)}
+       local facet=$SINGLEAGT
+       local agents=${1:-$(facet_active_host $facet)}
+       local mdtno
+       local idx
+       local oldstate
+       local mdt_hsmctrl
+       local hsm_root=$(copytool_device $facet)
+       local end_wait=$(( SECONDS + TIMEOUT ))
 
        do_nodesv $agents "pkill -INT -x $HSMTOOL_BASE" || return 0
-       sleep 1
-       echo "Copytool is stopped on $agents"
+
+       while (( SECONDS < end_wait )); do
+               sleep 2
+               do_nodesv $agents "pgrep -x $HSMTOOL_BASE"
+               if [ $? -ne 0 ]; then
+                       echo "Copytool is stopped on $agents"
+                       break
+               fi
+               echo "Copytool still running on $agents"
+       done
+       if do_nodesv $agents "pgrep -x $HSMTOOL_BASE"; then
+               error "Copytool failed to stop in ${TIMEOUT}s ..."
+       else
+               echo "Copytool has stopped in " \
+                    "$((TIMEOUT - (end_wait - SECONDS)))s."
+       fi
+
+       # clean all CDTs orphans requests from previous tests
+       # that would otherwise need to timeout to clear.
+       for mdtno in $(seq 1 $MDSCOUNT); do
+               idx=$(($mdtno - 1))
+               mdt_hsmctrl="mdt.$FSNAME-MDT000${idx}.hsm_control"
+               oldstate=$(do_facet mds${mdtno} "$LCTL get_param -n " \
+                                  "$mdt_hsmctrl")
+               # skip already stop[ed,ing] CDTs
+               echo $oldstate | grep stop && continue
+
+               do_facet mds${mdtno} "$LCTL set_param $mdt_hsmctrl=shutdown"
+               wait_result mds${mdtno} "$LCTL get_param -n $mdt_hsmctrl" \
+                       "stopped" 20 ||
+                       error "mds${mdtno} cdt state is not stopped"
+               do_facet mds${mdtno} "$LCTL set_param $mdt_hsmctrl=$oldstate"
+               wait_result mds${mdtno} "$LCTL get_param -n $mdt_hsmctrl" \
+                       "$oldstate" 20 ||
+                       error "mds${mdtno} cdt state is not $oldstate"
+       done
+       if do_facet $facet "df $hsm_root" >/dev/null 2>&1 ; then
+               do_facet $facet "rm -rf $hsm_root/*"
+       fi
 }
 
 copytool_suspend() {
@@ -179,7 +320,7 @@ copytool_suspend() {
 
 copytool_remove_backend() {
        local fid=$1
-       local be=$(find $HSM_ARCHIVE -name $fid)
+       local be=$(do_facet $SINGLEAGT find $HSM_ARCHIVE -name $fid)
        echo "Remove from backend: $fid = $be"
        do_facet $SINGLEAGT rm -f $be
 }
@@ -195,7 +336,7 @@ make_archive() {
        local file=$HSM_ARCHIVE/$1
        do_facet $SINGLEAGT mkdir -p $(dirname $file)
        do_facet $SINGLEAGT dd if=/dev/urandom of=$file count=32 bs=1000000 ||
-               error "cannot create $file"
+               file_creation_failure dd $file $?
 }
 
 copy2archive() {
@@ -204,20 +345,66 @@ copy2archive() {
        do_facet $SINGLEAGT cp -p $1 $file || error "cannot copy $1 to $file"
 }
 
+mdts_set_param() {
+       local arg=$1
+       local key=$2
+       local value=$3
+       local mdtno
+       local rc=0
+       if [[ "$value" != "" ]]; then
+               value="=$value"
+       fi
+       for mdtno in $(seq 1 $MDSCOUNT); do
+               local idx=$(($mdtno - 1))
+               local facet=mds${mdtno}
+               # if $arg include -P option, run 1 set_param per MDT on the MGS
+               # else, run set_param on each MDT
+               [[ $arg = *"-P"* ]] && facet=mgs
+               do_facet $facet $LCTL set_param $arg mdt.${MDT[$idx]}.$key$value
+               [[ $? != 0 ]] && rc=1
+       done
+       return $rc
+}
+
+mdts_check_param() {
+       local key="$1"
+       local target="$2"
+       local timeout="$3"
+       local mdtno
+       for mdtno in $(seq 1 $MDSCOUNT); do
+               local idx=$(($mdtno - 1))
+               wait_result mds${mdtno} \
+                       "$LCTL get_param -n $MDT_PREFIX${idx}.$key" "$target" \
+                       $timeout ||
+                       error "$key state is not '$target' on mds${mdtno}"
+       done
+}
+
 changelog_setup() {
-       CL_USER=$(do_facet $SINGLEMDS $LCTL --device $MDT0\
-                 changelog_register -n)
-       do_facet $SINGLEMDS lctl set_param mdd.$MDT0.changelog_mask="+hsm"
-       $LFS changelog_clear $MDT0 $CL_USER 0
+       CL_USERS=()
+       local mdtno
+       for mdtno in $(seq 1 $MDSCOUNT); do
+               local idx=$(($mdtno - 1))
+               local cl_user=$(do_facet mds${mdtno} $LCTL \
+                            --device ${MDT[$idx]} \
+                            changelog_register -n)
+               CL_USERS+=($cl_user)
+               do_facet mds${mdtno} lctl set_param \
+                       mdd.${MDT[$idx]}.changelog_mask="+hsm"
+               $LFS changelog_clear ${MDT[$idx]} $cl_user 0
+       done
 }
 
 changelog_cleanup() {
-#      $LFS changelog $MDT0
-       [[ -n "$CL_USER" ]] || return 0
-
-       $LFS changelog_clear $MDT0 $CL_USER 0
-       do_facet $SINGLEMDS lctl --device $MDT0 changelog_deregister $CL_USER
-       CL_USER=
+       local mdtno
+       for mdtno in $(seq 1 $MDSCOUNT); do
+               local idx=$(($mdtno - 1))
+               [[ -z  ${CL_USERS[$idx]} ]] && continue
+               $LFS changelog_clear ${MDT[$idx]} ${CL_USERS[$idx]} 0
+               do_facet mds${mdtno} lctl --device ${MDT[$idx]} \
+                       changelog_deregister ${CL_USERS[$idx]}
+       done
+       CL_USERS=()
 }
 
 changelog_get_flags() {
@@ -238,64 +425,57 @@ set_hsm_param() {
        local param=$1
        local value=$2
        local opt=$3
-       if [[ "$value" != "" ]]; then
-               value="=$value"
-       fi
-       do_facet $SINGLEMDS $LCTL set_param $opt -n $HSM_PARAM.$param$value
+       mdts_set_param "$opt -n" "hsm.$param" "$value"
        return $?
 }
 
 set_test_state() {
        local cmd=$1
        local target=$2
-       do_facet $SINGLEMDS $LCTL set_param $MDT_PARAM.hsm_control=$cmd
-       wait_result $SINGLEMDS "$LCTL get_param -n $MDT_PARAM.hsm_control"\
-               $target 10 || error "cdt state is not $target"
+       mdts_set_param "" hsm_control "$cmd"
+       mdts_check_param hsm_control "$target" 10
 }
 
 cdt_set_sanity_policy() {
        if [[ "$CDT_POLICY_HAD_CHANGED" ]]
        then
                # clear all
-               do_facet $SINGLEMDS $LCTL set_param $HSM_PARAM.policy=+NRA
-               do_facet $SINGLEMDS $LCTL set_param $HSM_PARAM.policy=-NBR
+               mdts_set_param "" hsm.policy "+NRA"
+               mdts_set_param "" hsm.policy "-NBR"
                CDT_POLICY_HAD_CHANGED=
        fi
 }
 
 cdt_set_no_retry() {
-       do_facet $SINGLEMDS $LCTL set_param $HSM_PARAM.policy=+NRA
+       mdts_set_param "" hsm.policy "+NRA"
        CDT_POLICY_HAD_CHANGED=true
 }
 
 cdt_clear_no_retry() {
-       do_facet $SINGLEMDS $LCTL set_param $HSM_PARAM.policy=-NRA
+       mdts_set_param "" hsm.policy "-NRA"
        CDT_POLICY_HAD_CHANGED=true
 }
 
 cdt_set_non_blocking_restore() {
-       do_facet $SINGLEMDS $LCTL set_param $HSM_PARAM.policy=+NBR
+       mdts_set_param "" hsm.policy "+NBR"
        CDT_POLICY_HAD_CHANGED=true
 }
 
 cdt_clear_non_blocking_restore() {
-       do_facet $SINGLEMDS $LCTL set_param $HSM_PARAM.policy=-NBR
+       mdts_set_param "" hsm.policy "-NBR"
        CDT_POLICY_HAD_CHANGED=true
 }
 
 cdt_clear_mount_state() {
-       do_facet $SINGLEMDS $LCTL set_param -d -P $MDT_PARAM.hsm_control
+       mdts_set_param "-P -d" hsm_control ""
 }
 
 cdt_set_mount_state() {
-       do_facet $SINGLEMDS $LCTL set_param -P $MDT_PARAM.hsm_control=$1
+       mdts_set_param "-P" hsm_control "$1"
 }
 
 cdt_check_state() {
-       local target=$1
-       wait_result $SINGLEMDS\
-               "$LCTL get_param -n $MDT_PARAM.hsm_control" "$target" 20 ||
-                       error "cdt state is not $target"
+       mdts_check_param hsm_control "$1" 20
 }
 
 cdt_disable() {
@@ -331,17 +511,19 @@ needclients() {
 
 path2fid() {
        $LFS path2fid $1 | tr -d '[]'
+       return ${PIPESTATUS[0]}
 }
 
 get_hsm_flags() {
        local f=$1
        local u=$2
+       local st
 
        if [[ $u == "user" ]]; then
-               local st=$($RUNAS $LFS hsm_state $f)
+               st=$($RUNAS $LFS hsm_state $f)
        else
-               local st=$($LFS hsm_state $f)
                u=root
+               st=$($LFS hsm_state $f)
        fi
 
        [[ $? == 0 ]] || error "$LFS hsm_state $f failed (run as $u)"
@@ -352,7 +534,8 @@ get_hsm_flags() {
 
 get_hsm_archive_id() {
        local f=$1
-       local st=$($LFS hsm_state $f)
+       local st
+       st=$($LFS hsm_state $f)
        [[ $? == 0 ]] || error "$LFS hsm_state $f failed"
 
        local ar=$(echo $st | grep "archive_id" | cut -f5 -d" " |
@@ -376,6 +559,15 @@ check_hsm_flags_user() {
        [[ $st == $fl ]] || error "hsm flags on $f are $st != $fl"
 }
 
+file_creation_failure() {
+       local cmd=$1
+       local f=$2
+       local err=$3
+
+       df $MOUNT $MOUNT2 >&2
+       error "cannot create $f with $cmd, status=$err"
+}
+
 copy_file() {
        local f=
 
@@ -389,30 +581,52 @@ copy_file() {
                f=${f/$DIR/$DIR2}
        fi
        rm -f $f
-       cp $1 $f || error "cannot copy $1 to $f"
+       cp $1 $f || file_creation_failure cp $f $?
+
        path2fid $f || error "cannot get fid on $f"
 }
 
 make_small() {
         local file2=${1/$DIR/$DIR2}
         dd if=/dev/urandom of=$file2 count=2 bs=1M conv=fsync ||
-               error "cannot create $file2"
+               file_creation_failure dd $file2 $?
+
         path2fid $1 || error "cannot get fid on $1"
 }
 
+make_small_sync() {
+       dd if=/dev/urandom of=$1 count=1 bs=1M conv=sync ||
+               file_creation_failure dd $1 $?
+       path2fid $1 || error "cannot get fid on $1"
+}
+
 cleanup_large_files() {
-       local ratio=$(df $MOUNT |awk '{print $5}' |sed 's/%//g' |grep -v Use)
+       local ratio=$(df -P $MOUNT | tail -1 | awk '{print $5}' |
+                     sed 's/%//g')
        [ $ratio -gt 50 ] && find $MOUNT -size +10M -exec rm -f {} \;
 }
 
+check_enough_free_space() {
+       local nb=$1
+       local unit=$2
+       local need=$((nb * unit /1024))
+       local free=$(df -kP $MOUNT | tail -1 | awk '{print $4}')
+       (( $need >= $free )) && return 1
+       return 0
+}
+
 make_large_for_striping() {
        local file2=${1/$DIR/$DIR2}
-       local sz=$($LCTL get_param -n lov.*-clilov-*.stripesize | head -1)
+       local sz=$($LCTL get_param -n lov.*-clilov-*.stripesize | head -n1)
 
        cleanup_large_files
 
+       check_enough_free_space 5 $sz
+       [ $? != 0 ] && return $?
+
        dd if=/dev/urandom of=$file2 count=5 bs=$sz conv=fsync ||
-               error "cannot create $file2"
+               file_creation_failure dd $file2 $?
+
        path2fid $1 || error "cannot get fid on $1"
 }
 
@@ -421,12 +635,16 @@ make_large_for_progress() {
 
        cleanup_large_files
 
+       check_enough_free_space 39 1000000
+       [ $? != 0 ] && return $?
+
        # big file is large enough, so copy time is > 30s
        # so copytool make 1 progress
        # size is not a multiple of 1M to avoid stripe
        # aligment
        dd if=/dev/urandom of=$file2 count=39 bs=1000000 conv=fsync ||
-               error "cannot create $file2"
+               file_creation_failure dd $file2 $?
+
        path2fid $1 || error "cannot get fid on $1"
 }
 
@@ -435,12 +653,15 @@ make_large_for_progress_aligned() {
 
        cleanup_large_files
 
+       check_enough_free_space 33 1048576
+       [ $? != 0 ] && return $?
+
        # big file is large enough, so copy time is > 30s
        # so copytool make 1 progress
        # size is a multiple of 1M to have stripe
        # aligment
        dd if=/dev/urandom of=$file2 count=33 bs=1M conv=fsync ||
-               error "cannot create $file2"
+               file_creation_failure dd $file2 $?
        path2fid $1 || error "cannot get fid on $1"
 }
 
@@ -449,9 +670,12 @@ make_large_for_cancel() {
 
        cleanup_large_files
 
+       check_enough_free_space 103 1048576
+       [ $? != 0 ] && return $?
+
        # Copy timeout is 100s. 105MB => 105s
        dd if=/dev/urandom of=$file2 count=103 bs=1M conv=fsync ||
-               error "cannot create $file2"
+               file_creation_failure dd $file2 $?
        path2fid $1 || error "cannot get fid on $1"
 }
 
@@ -465,19 +689,22 @@ wait_request_state() {
        local fid=$1
        local request=$2
        local state=$3
+       # 4th arg (mdt index) is optional
+       local mdtidx=${4:-0}
+       local mds=mds$(($mdtidx + 1))
 
-       local cmd="$LCTL get_param -n $HSM_PARAM.agent_actions"
+       local cmd="$LCTL get_param -n ${MDT_PREFIX}${mdtidx}.hsm.actions"
        cmd+=" | awk '/'$fid'.*action='$request'/ {print \\\$13}' | cut -f2 -d="
 
-       wait_result $SINGLEMDS "$cmd" $state 100 ||
-               error "request on $fid is not $state"
+       wait_result $mds "$cmd" $state 200 ||
+               error "request on $fid is not $state on $mds"
 }
 
 get_request_state() {
        local fid=$1
        local request=$2
 
-       do_facet $SINGLEMDS "$LCTL get_param -n $HSM_PARAM.agent_actions |"\
+       do_facet $SINGLEMDS "$LCTL get_param -n $HSM_PARAM.actions |"\
                "awk '/'$fid'.*action='$request'/ {print \\\$13}' | cut -f2 -d="
 }
 
@@ -485,14 +712,16 @@ get_request_count() {
        local fid=$1
        local request=$2
 
-       do_facet $SINGLEMDS "$LCTL get_param -n $HSM_PARAM.agent_actions |"\
+       do_facet $SINGLEMDS "$LCTL get_param -n $HSM_PARAM.actions |"\
                "awk -vn=0 '/'$fid'.*action='$request'/ {n++}; END {print n}'"
 }
 
 wait_all_done() {
        local timeout=$1
+       local fid=$2
 
-       local cmd="$LCTL get_param -n $HSM_PARAM.agent_actions"
+       local cmd="$LCTL get_param -n $HSM_PARAM.actions"
+       [[ -n $fid ]] && cmd+=" | grep '$fid'"
        cmd+=" | egrep 'WAITING|STARTED'"
 
        wait_result $SINGLEMDS "$cmd" "" $timeout ||
@@ -504,8 +733,20 @@ wait_for_grace_delay() {
        sleep $val
 }
 
-MDT0=$($LCTL get_param -n mdc.*.mds_server_uuid |
-       awk '{gsub(/_UUID/,""); print $1}' | head -1)
+parse_json_event() {
+       local raw_event=$1
+
+       # python2.6 in EL6 includes an internal json module
+       local json_parser='import json; import fileinput;'
+       json_parser+=' print "\n".join(["local %s=\"%s\"" % tuple for tuple in '
+       json_parser+='json.loads([line for line in '
+       json_parser+='fileinput.input()][0]).items()])'
+
+       echo $raw_event | python -c "$json_parser"
+}
+
+# populate MDT device array
+get_mdt_devices
 
 # initiate variables
 init_agt_vars
@@ -619,7 +860,7 @@ test_3() {
                error "user could not change hsm flags"
        dd if=/etc/passwd of=$f.append bs=1 count=3\
           conv=notrunc oflag=append status=noxfer ||
-               error "could not append to test file"
+               file_creation_failure dd $f.append $?
        check_hsm_flags $f.append "0x00000003"
 
        # Modify a file sets it dirty
@@ -628,7 +869,7 @@ test_3() {
                error "user could not change hsm flags"
        dd if=/dev/zero of=$f.modify bs=1 count=3\
           conv=notrunc status=noxfer ||
-               error "could not modify test file"
+               file_creation_failure dd $f.modify $?
        check_hsm_flags $f.modify "0x00000003"
 
        # Open O_TRUNC sets dirty
@@ -689,7 +930,7 @@ test_9() {
 
        copytool_cleanup
 }
-run_test 9 "Use of explict archive number, with dedicated copytool"
+run_test 9 "Use of explicit archive number, with dedicated copytool"
 
 test_9a() {
        needclients 3 || return 0
@@ -802,7 +1043,7 @@ test_10d() {
 }
 run_test 10d "Archive a file on the default archive id"
 
-test_11() {
+test_11a() {
        mkdir -p $DIR/$tdir
        copy2archive /etc/hosts $tdir/$tfile
        local f=$DIR/$tdir/$tfile
@@ -812,7 +1053,7 @@ test_11() {
        check_hsm_flags $f "0x0000000d"
 
        local LSZ=$(stat -c "%s" $f)
-       local ASZ=$(stat -c "%s" $HSM_ARCHIVE/$tdir/$tfile)
+       local ASZ=$(do_facet $SINGLEAGT stat -c "%s" $HSM_ARCHIVE/$tdir/$tfile)
 
        echo "Verifying imported size $LSZ=$ASZ"
        [[ $LSZ -eq $ASZ ]] || error "Incorrect size $LSZ != $ASZ"
@@ -826,7 +1067,31 @@ test_11() {
        local AFILE=$(do_facet $SINGLEAGT ls $HSM_ARCHIVE'/*/*/*/*/*/*/'$fid) ||
                error "fid $fid not in archive $HSM_ARCHIVE"
 }
-run_test 11 "Import a file"
+run_test 11a "Import a file"
+
+test_11b() {
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid=$(copy_file /etc/hosts $f)
+       $LFS hsm_archive -a $HSM_ARCHIVE_NUMBER $f ||
+               error "hsm_archive failed"
+       wait_request_state $fid ARCHIVE SUCCEED
+
+       local FILE_HASH=$(md5sum $f)
+       rm -f $f
+
+       import_file $fid $f
+
+       echo "$FILE_HASH" | md5sum -c
+
+       [[ $? -eq 0 ]] || error "Restored file differs"
+
+       copytool_cleanup
+}
+run_test 11b "Import a deleted file using its FID"
 
 test_12a() {
        # test needs a running copytool
@@ -837,16 +1102,16 @@ test_12a() {
 
        local f=$DIR/$tdir/$tfile
        import_file $tdir/$tfile $f
-       local f=$DIR2/$tdir/$tfile
+       local f2=$DIR2/$tdir/$tfile
        echo "Verifying released state: "
-       check_hsm_flags $f "0x0000000d"
+       check_hsm_flags $f2 "0x0000000d"
 
-       local fid=$(path2fid $f)
-       $LFS hsm_restore $f
+       local fid=$(path2fid $f2)
+       $LFS hsm_restore $f2
        wait_request_state $fid RESTORE SUCCEED
 
        echo "Verifying file state: "
-       check_hsm_flags $f "0x00000009"
+       check_hsm_flags $f2 "0x00000009"
 
        do_facet $SINGLEAGT diff -q $HSM_ARCHIVE/$tdir/$tfile $f
 
@@ -890,7 +1155,10 @@ test_12c() {
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
        $LFS setstripe -c 2 $f
-       local fid=$(make_large_for_striping $f)
+       local fid
+       fid=$(make_large_for_striping $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        local FILE_CRC=$(md5sum $f)
 
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
@@ -1066,6 +1334,77 @@ test_12n() {
 }
 run_test 12n "Import/implicit restore/release"
 
+test_12o() {
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid=$(copy_file /etc/hosts $f)
+
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+       wait_request_state $fid ARCHIVE SUCCEED
+       $LFS hsm_release $f || error "release of $f failed"
+
+#define OBD_FAIL_MDS_HSM_SWAP_LAYOUTS          0x152
+       do_facet $SINGLEMDS lctl set_param fail_loc=0x152
+
+       # set no retry action mode
+       cdt_set_no_retry
+
+       diff -q /etc/hosts $f
+       local st=$?
+
+       # we check we had a restore failure
+       wait_request_state $fid RESTORE FAILED
+
+       [[ $st -eq 0 ]] && error "Restore must fail"
+
+       # remove no retry action mode
+       cdt_clear_no_retry
+
+       # check file is still released
+       check_hsm_flags $f "0x0000000d"
+
+       # retry w/o failure injection
+       do_facet $SINGLEMDS lctl set_param fail_loc=0
+
+       # to be sure previous RESTORE result is gone
+       cdt_purge
+       wait_for_grace_delay
+
+       diff -q /etc/hosts $f
+       st=$?
+
+       # we check we had a restore done
+       wait_request_state $fid RESTORE SUCCEED
+
+       [[ $st -eq 0 ]] || error "Restored file differs"
+
+       copytool_cleanup
+}
+run_test 12o "Layout-swap failure during Restore leaves file released"
+
+test_12p() {
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid=$(copy_file /etc/hosts $f)
+
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+       wait_request_state $fid ARCHIVE SUCCEED
+       do_facet $SINGLEAGT cat $f > /dev/null || error "cannot cat $f"
+       $LFS hsm_release $f || error "cannot release $f"
+       do_facet $SINGLEAGT cat $f > /dev/null || error "cannot cat $f"
+       $LFS hsm_release $f || error "cannot release $f"
+       do_facet $SINGLEAGT cat $f > /dev/null || error "cannot cat $f"
+
+       copytool_cleanup
+}
+run_test 12p "implicit restore of a file on copytool mount point"
+
 test_13() {
        # test needs a running copytool
        copytool_setup
@@ -1082,8 +1421,8 @@ test_13() {
                        CURR_FILE="$CURR_DIR/$tfile.$f"
                        # write file-specific data
                        do_facet $SINGLEAGT \
-                               echo "d=$d, f=$f, dir=$CURR_DIR, "\
-                                    "file=$CURR_FILE" > $CURR_FILE
+                               "echo d=$d, f=$f, dir=$CURR_DIR, "\
+                                       "file=$CURR_FILE > $CURR_FILE"
                done
        done
        # import to Lustre
@@ -1260,19 +1599,41 @@ test_21() {
        local fid=$(make_small $f)
        check_hsm_flags $f "0x00000000"
 
+       # LU-4388/LU-4389 - ZFS does not report full number of blocks
+       # used until file is flushed to disk
+       if [  $(facet_fstype ost1) == "zfs" ]; then
+           # this causes an OST_SYNC rpc to be sent
+           dd if=/dev/zero of=$f bs=512 count=1 oflag=sync conv=notrunc,fsync
+           # clear locks to reread file data
+           cancel_lru_locks osc
+       fi
+
+       local orig_size=$(stat -c "%s" $f)
+       local orig_blocks=$(stat -c "%b" $f)
+
+       start_full_debug_logging
+
        $LFS hsm_archive $f || error "could not archive file"
        wait_request_state $fid ARCHIVE SUCCEED
 
-       [ $(stat -c "%b" $f) -ne "1" ] || error "wrong block number"
-       local sz=$(stat -c "%s" $f)
-       [ $sz -ne "0" ] || error "file size should not be zero"
+       local blocks=$(stat -c "%b" $f)
+       [ $blocks -eq $orig_blocks ] ||
+               error "$f: wrong block number after archive: " \
+                     "$blocks != $orig_blocks"
+       local size=$(stat -c "%s" $f)
+       [ $size -eq $orig_size ] ||
+               error "$f: wrong size after archive: $size != $orig_size"
 
        # Release and check states
        $LFS hsm_release $f || error "could not release file"
        check_hsm_flags $f "0x0000000d"
 
-       [ $(stat -c "%b" $f) -eq "1" ] || error "wrong block number"
-       [ $(stat -c "%s" $f) -eq $sz ] || error "wrong file size"
+       blocks=$(stat -c "%b" $f)
+       [ $blocks -gt 5 ] &&
+               error "$f: too many blocks after release: $blocks > 5"
+       size=$(stat -c "%s" $f)
+       [ $size -ne $orig_size ] &&
+               error "$f: wrong size after release: $size != $orig_size"
 
        # Check we can release an file without stripe info
        f=$f.nolov
@@ -1290,6 +1651,8 @@ test_21() {
        $LFS hsm_release $f || fail "second release should succeed"
        check_hsm_flags $f "0x0000000d"
 
+       stop_full_debug_logging
+
        copytool_cleanup
 }
 run_test 21 "Simple release tests"
@@ -1471,7 +1834,7 @@ test_24b() {
        copytool_setup
        mkdir -p $DIR/$tdir
 
-       # Check that root can do HSM actions on a ordinary user's file.
+       # Check that root can do HSM actions on a regular user's file.
        rm -f $file
        fid=$(make_small $file)
        sum0=$(md5sum $file)
@@ -1485,8 +1848,8 @@ test_24b() {
        $LFS hsm_archive $file
        wait_request_state $fid ARCHIVE SUCCEED
 
-       $LFS hsm_release $file ||
-               check_hsm_flags $file "0x0000000d"
+       $LFS hsm_release $file
+       check_hsm_flags $file "0x0000000d"
 
        $LFS hsm_restore $file
        wait_request_state $fid RESTORE SUCCEED
@@ -1495,8 +1858,8 @@ test_24b() {
        $RUNAS $LFS hsm_state $file ||
                error "user '$RUNAS_ID' cannot get HSM state of '$file'"
 
-       $LFS hsm_release $file ||
-               check_hsm_flags $file "0x0000000d"
+       $LFS hsm_release $file
+       check_hsm_flags $file "0x0000000d"
 
        # Check that ordinary user can accessed released file.
        sum1=$($RUNAS md5sum $file) ||
@@ -1509,6 +1872,134 @@ test_24b() {
 }
 run_test 24b "root can archive, release, and restore user files"
 
+cleanup_test_24c() {
+       trap 0
+       set_hsm_param user_request_mask RESTORE
+       set_hsm_param group_request_mask RESTORE
+       set_hsm_param other_request_mask RESTORE
+}
+
+test_24c() {
+       local file=$DIR/$tdir/$tfile
+       local action=archive
+       local user_save
+       local group_save
+       local other_save
+
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+
+       # Save the default masks and check that cleanup_24c will
+       # restore the request masks correctly.
+       user_save=$(get_hsm_param user_request_mask)
+       group_save=$(get_hsm_param group_request_mask)
+       other_save=$(get_hsm_param other_request_mask)
+
+       [ "$user_save" == RESTORE ] ||
+               error "user_request_mask is '$user_save' expected 'RESTORE'"
+       [ "$group_save" == RESTORE ] ||
+               error "group_request_mask is '$group_save' expected 'RESTORE'"
+       [ "$other_save" == RESTORE ] ||
+               error "other_request_mask is '$other_save' expected 'RESTORE'"
+
+       trap cleanup_test_24c EXIT
+
+       # User.
+       rm -f $file
+       make_small $file
+       chown $RUNAS_ID:nobody $file ||
+               error "cannot chown '$file' to '$RUNAS_ID:nobody'"
+
+       set_hsm_param user_request_mask ""
+       $RUNAS $LFS hsm_$action $file &&
+               error "$action by user should fail"
+
+       set_hsm_param user_request_mask $action
+       $RUNAS $LFS hsm_$action $file ||
+               error "$action by user should succeed"
+
+       # Group.
+       rm -f $file
+       make_small $file
+       chown nobody:$RUNAS_GID $file ||
+               error "cannot chown '$file' to 'nobody:$RUNAS_GID'"
+
+       set_hsm_param group_request_mask ""
+       $RUNAS $LFS hsm_$action $file &&
+               error "$action by group should fail"
+
+       set_hsm_param group_request_mask $action
+       $RUNAS $LFS hsm_$action $file ||
+               error "$action by group should succeed"
+
+       # Other.
+       rm -f $file
+       make_small $file
+       chown nobody:nobody $file ||
+               error "cannot chown '$file' to 'nobody:nobody'"
+
+       set_hsm_param other_request_mask ""
+       $RUNAS $LFS hsm_$action $file &&
+               error "$action by other should fail"
+
+       set_hsm_param other_request_mask $action
+       $RUNAS $LFS hsm_$action $file ||
+               error "$action by other should succeed"
+
+       copytool_cleanup
+       cleanup_test_24c
+}
+run_test 24c "check that user,group,other request masks work"
+
+cleanup_test_24d() {
+       trap 0
+       mount -o remount,rw $MOUNT2
+}
+
+test_24d() {
+       local file1=$DIR/$tdir/$tfile
+       local file2=$DIR2/$tdir/$tfile
+       local fid1
+       local fid2
+
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+       rm -f $file1
+       fid1=$(make_small $file1)
+
+       trap cleanup_test_24d EXIT
+
+       mount -o remount,ro $MOUNT2
+
+       fid2=$(path2fid $file2)
+       [ "$fid1" == "$fid2" ] ||
+               error "FID mismatch '$fid1' != '$fid2'"
+
+       $LFS hsm_archive $file2 &&
+               error "archive should fail on read-only mount"
+       check_hsm_flags $file1 "0x00000000"
+
+       $LFS hsm_archive $file1
+       wait_request_state $fid1 ARCHIVE SUCCEED
+
+       $LFS hsm_release $file1
+       $LFS hsm_restore $file2
+       wait_request_state $fid1 RESTORE SUCCEED
+
+       $LFS hsm_release $file1 || error "cannot release '$file1'"
+       dd if=$file2 of=/dev/null bs=1M || "cannot read '$file2'"
+
+       $LFS hsm_release $file2 &&
+               error "release should fail on read-only mount"
+
+       copytool_cleanup
+       cleanup_test_24d
+}
+run_test 24d "check that read-only mounts are respected"
+
 test_25a() {
        # test needs a running copytool
        copytool_setup
@@ -1562,7 +2053,10 @@ test_26() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
 
@@ -1599,7 +2093,10 @@ test_27b() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
        $LFS hsm_release $f
@@ -1618,7 +2115,10 @@ test_28() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
 
@@ -1699,6 +2199,47 @@ test_30b() {
 }
 run_test 30b "Restore at exec (release case)"
 
+test_30c() {
+       needclients 2 || return 0
+
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/SLEEP
+       local slp_sum1=$(md5sum /bin/sleep)
+       local fid=$(copy_file /bin/sleep $f)
+       chmod 755 $f
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+       wait_request_state $fid ARCHIVE SUCCEED
+       $LFS hsm_release $f
+       check_hsm_flags $f "0x0000000d"
+       # set no retry action mode
+       cdt_set_no_retry
+       do_node $CLIENT2 "$f 10" &
+       local pid=$!
+       sleep 3
+       echo 'Hi!' > $f
+       [[ $? == 0 ]] && error "Update during exec of released file must fail"
+       wait $pid
+       [[ $? == 0 ]] || error "Execution failed during run"
+       cmp /bin/sleep $f
+       if [[ $? != 0 ]]; then
+               local slp_sum2=$(md5sum /bin/sleep)
+               # in case sleep file is modified during the test
+               [[ $slp_sum1 == $slp_sum2 ]] &&
+                       error "Binary overwritten during exec"
+       fi
+
+       # cleanup
+       # remove no try action mode
+       cdt_clear_no_retry
+       check_hsm_flags $f "0x00000009"
+
+       copytool_cleanup
+}
+run_test 30c "Update during exec of released file must fail"
+
 restore_and_check_size() {
        local f=$1
        local fid=$2
@@ -1724,11 +2265,11 @@ restore_and_check_size() {
                cpt=$((cpt + 1))
        done
        if [[ $cpt -lt 10 ]]; then
-               echo " restore is too long"
-       else
                echo " "done
+       else
+               echo " restore is too long"
+               wait_request_state $fid RESTORE SUCCEED
        fi
-       wait_request_state $fid RESTORE SUCCEED
        return $err
 }
 
@@ -1761,7 +2302,10 @@ test_31b() {
        mkdir -p $DIR/$tdir
 
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
        $LFS hsm_release $f
@@ -1782,7 +2326,10 @@ test_31c() {
        mkdir -p $DIR/$tdir
 
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress_aligned $f)
+       local fid
+       fid=$(make_large_for_progress_aligned $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
        $LFS hsm_release $f
@@ -1803,11 +2350,23 @@ test_33() {
        mkdir -p $DIR/$tdir
 
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
        $LFS hsm_release $f
 
+       # to be sure wait_all_done will not be mislead by previous tests
+       # and ops.
+       cdt_purge
+       wait_for_grace_delay
+       # Also raise grace_delay significantly so the Canceled
+       # Restore action will stay enough long avail.
+       local old_grace=$(get_hsm_param grace_delay)
+       set_hsm_param grace_delay 100
+
        md5sum $f >/dev/null &
        local pid=$!
        wait_request_state $fid RESTORE STARTED
@@ -1820,8 +2379,29 @@ test_33() {
 
        $LFS hsm_cancel $f
 
-       wait_request_state $fid RESTORE CANCELED
-       wait_request_state $fid CANCEL SUCCEED
+       # instead of waiting+checking both Restore and Cancel ops
+       # sequentially, wait for both to be finished and then check
+       # each results.
+       wait_all_done 100 $fid
+       local rstate=$(get_request_state $fid RESTORE)
+       local cstate=$(get_request_state $fid CANCEL)
+
+       # restore orig grace_delay.
+       set_hsm_param grace_delay $old_grace
+
+       if [[ "$rstate" == "CANCELED" ]] ; then
+               [[ "$cstate" == "SUCCEED" ]] ||
+                       error "Restore state is CANCELED and Cancel state " \
+                              "is not SUCCEED but $cstate"
+               echo "Restore state is CANCELED, Cancel state is SUCCEED"
+       elif [[ "$rstate" == "SUCCEED" ]] ; then
+               [[ "$cstate" == "FAILED" ]] ||
+                       error "Restore state is SUCCEED and Cancel state " \
+                               "is not FAILED but $cstate"
+               echo "Restore state is SUCCEED, Cancel state is FAILED"
+       else
+               error "Restore state is $rstate and Cancel state is $cstate"
+       fi
 
        [ -z $killed ] ||
                error "Cannot kill process waiting for restore ($killed)"
@@ -1837,7 +2417,10 @@ test_34() {
        mkdir -p $DIR/$tdir
 
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
        $LFS hsm_release $f
@@ -1870,7 +2453,10 @@ test_35() {
 
        local f=$DIR/$tdir/$tfile
        local f1=$DIR/$tdir/$tfile-1
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        local fid1=$(copy_file /etc/passwd $f1)
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
@@ -1906,7 +2492,10 @@ test_36() {
        mkdir -p $DIR/$tdir
 
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
        $LFS hsm_release $f
@@ -1958,7 +2547,13 @@ test_40() {
                        fid=$(copy_file /etc/hosts $f.$p.$i)
                done
        done
-       copytool_setup
+       # force copytool to use a local/temp archive dir to ensure best
+       # performance vs remote/NFS mounts used in auto-tests
+       if do_facet $SINGLEAGT "df --local $HSM_ARCHIVE" >/dev/null 2>&1 ; then
+               copytool_setup
+       else
+               copytool_setup $SINGLEAGT $MOUNT $HSM_ARCHIVE_NUMBER $TMP/$tdir
+       fi
        # to be sure wait_all_done will not be mislead by previous tests
        cdt_purge
        wait_for_grace_delay
@@ -2093,7 +2688,9 @@ test_56() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
 
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f ||
                error "could not archive file"
@@ -2202,10 +2799,314 @@ test_58() {
 }
 run_test 58 "Truncate a released file will trigger restore"
 
-test_90() {
-       file_count=57
+test_60() {
+       # This test validates the fix for LU-4512. Ensure that the -u
+       # option changes the progress reporting interval from the
+       # default (30 seconds) to the user-specified interval.
+       local interval=5
+       local progress_timeout=$((interval * 4))
+
+       # test needs a new running copytool
+       copytool_cleanup
+       HSMTOOL_UPDATE_INTERVAL=$interval copytool_setup
+
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
+       local mdtidx=0
+       local mdt=${MDT_PREFIX}${mdtidx}
+       local mds=mds$((mdtidx + 1))
+
+       # Wait for copytool to register
+       wait_update_facet $mds \
+               "$LCTL get_param -n ${mdt}.hsm.agents | grep -o ^uuid" \
+               uuid 100 || error "coyptool failed to register with $mdt"
+
+       local start_at=$(date +%s)
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f ||
+               error "could not archive file"
+
+       local agent=$(facet_active_host $SINGLEAGT)
+       local prefix=$TESTLOG_PREFIX
+       [[ -z "$TESTNAME" ]] || prefix=$prefix.$TESTNAME
+       local copytool_log=$prefix.copytool_log.$agent.log
+
+
+       wait_update $agent \
+           "grep -o start.copy $copytool_log" "start copy" 100 ||
+               error "copytool failed to start"
+
+       local cmd="$LCTL get_param -n ${mdt}.hsm.active_requests"
+       cmd+=" | awk '/'$fid'.*action=ARCHIVE/ {print \\\$12}' | cut -f2 -d="
+
+       local RESULT
+       local WAIT=0
+       local sleep=1
+
+       echo -n "Expecting a progress update within $progress_timeout seconds... "
+       while [ true ]; do
+               RESULT=$(do_node $(facet_active_host $mds) "$cmd")
+               if [ $RESULT -gt 0 ]; then
+                       echo "$RESULT bytes copied in $WAIT seconds."
+                       break
+               elif [ $WAIT -ge $progress_timeout ]; then
+                       error "Timed out waiting for progress update!"
+                       break
+               fi
+               WAIT=$((WAIT + sleep))
+               sleep $sleep
+       done
+
+       local finish_at=$(date +%s)
+       local elapsed=$((finish_at - start_at))
+
+       # Ensure that the progress update occurred within the expected window.
+       if [ $elapsed -lt $interval ]; then
+               error "Expected progress update after at least $interval seconds"
+       fi
+
+       cdt_clear_no_retry
+       copytool_cleanup
+}
+run_test 60 "Changing progress update interval from default"
+
+test_70() {
+       # test needs a new running copytool
+       copytool_cleanup
+       copytool_monitor_setup
+       HSMTOOL_EVENT_FIFO=$HSMTOOL_MONITOR_DIR/fifo copytool_setup
+
+       # Just start and stop the copytool to generate events.
+       cdt_clear_no_retry
+
+       # Wait for the copytool to register.
+       wait_update --verbose $(facet_active_host mds1) \
+               "$LCTL get_param -n ${MDT_PREFIX}0.hsm.agents | grep -o ^uuid" \
+               uuid 100 ||
+               error "copytool failed to register with MDT0000"
+
+       copytool_cleanup
+
+       local REGISTER_EVENT
+       local UNREGISTER_EVENT
+       while read event; do
+               local parsed=$(parse_json_event "$event")
+               if [ -z "$parsed" ]; then
+                       error "Copytool sent malformed event: $event"
+               fi
+               eval $parsed
+
+               if [ $event_type == "REGISTER" ]; then
+                       REGISTER_EVENT=$event
+               elif [ $event_type == "UNREGISTER" ]; then
+                       UNREGISTER_EVENT=$event
+               fi
+       done < <(echo $"$(get_copytool_event_log)")
+
+       if [ -z "$REGISTER_EVENT" ]; then
+               error "Copytool failed to send register event to FIFO"
+       fi
+
+       if [ -z "$UNREGISTER_EVENT" ]; then
+               error "Copytool failed to send unregister event to FIFO"
+       fi
+
+       copytool_monitor_cleanup
+       echo "Register/Unregister events look OK."
+}
+run_test 70 "Copytool logs JSON register/unregister events to FIFO"
+
+test_71() {
+       # Bump progress interval for livelier events.
+       local interval=5
+
+       # test needs a new running copytool
+       copytool_cleanup
+       copytool_monitor_setup
+       HSMTOOL_UPDATE_INTERVAL=$interval \
+       HSMTOOL_EVENT_FIFO=$HSMTOOL_MONITOR_DIR/fifo copytool_setup
+
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f ||
+               error "could not archive file"
+       wait_request_state $fid ARCHIVE SUCCEED
+
+       local expected_fields="event_time data_fid source_fid"
+       expected_fields+=" total_bytes current_bytes"
+
+       local START_EVENT
+       local FINISH_EVENT
+       while read event; do
+               # Make sure we're not getting anything from previous events.
+               for field in $expected_fields; do
+                       unset $field
+               done
+
+               local parsed=$(parse_json_event "$event")
+               if [ -z "$parsed" ]; then
+                       error "Copytool sent malformed event: $event"
+               fi
+               eval $parsed
+
+               if [ $event_type == "ARCHIVE_START" ]; then
+                       START_EVENT=$event
+                       continue
+               elif [ $event_type == "ARCHIVE_FINISH" ]; then
+                       FINISH_EVENT=$event
+                       continue
+               elif [ $event_type != "ARCHIVE_RUNNING" ]; then
+                       continue
+               fi
+
+               # Do some simple checking of the progress update events.
+               for expected_field in $expected_fields; do
+                       if [ -z ${!expected_field+x} ]; then
+                               error "Missing $expected_field field in event"
+                       fi
+               done
+
+               if [ $total_bytes -eq 0 ]; then
+                       error "Expected total_bytes to be > 0"
+               fi
+
+               # These should be identical throughout an archive
+               # operation.
+               if [ $source_fid != $data_fid ]; then
+                       error "Expected source_fid to equal data_fid"
+               fi
+       done < <(echo $"$(get_copytool_event_log)")
+
+       if [ -z "$START_EVENT" ]; then
+               error "Copytool failed to send archive start event to FIFO"
+       fi
+
+       if [ -z "$FINISH_EVENT" ]; then
+               error "Copytool failed to send archive finish event to FIFO"
+       fi
+
+       echo "Archive events look OK."
+
+       cdt_clear_no_retry
+       copytool_cleanup
+       copytool_monitor_cleanup
+}
+run_test 71 "Copytool logs JSON archive events to FIFO"
+
+test_72() {
+       # Bump progress interval for livelier events.
+       local interval=5
+
+       # test needs a new running copytool
+       copytool_cleanup
+       copytool_monitor_setup
+       HSMTOOL_UPDATE_INTERVAL=$interval \
+       HSMTOOL_EVENT_FIFO=$HSMTOOL_MONITOR_DIR/fifo copytool_setup
+       local test_file=$HSMTOOL_MONITOR_DIR/file
+
+       local cmd="dd if=/dev/urandom of=$test_file count=16 bs=1000000 "
+       cmd+="conv=fsync"
+       do_facet $SINGLEAGT "$cmd" ||
+               error "cannot create $test_file on $SINGLEAGT"
+       copy2archive $test_file $tdir/$tfile
+
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       import_file $tdir/$tfile $f
+       f=$DIR2/$tdir/$tfile
+       echo "Verifying released state: "
+       check_hsm_flags $f "0x0000000d"
+
+       local fid=$(path2fid $f)
+       $LFS hsm_restore $f
+       wait_request_state $fid RESTORE SUCCEED
+
+       local expected_fields="event_time data_fid source_fid"
+       expected_fields+=" total_bytes current_bytes"
+
+       local START_EVENT
+       local FINISH_EVENT
+       while read event; do
+               # Make sure we're not getting anything from previous events.
+               for field in $expected_fields; do
+                       unset $field
+               done
+
+               local parsed=$(parse_json_event "$event")
+               if [ -z "$parsed" ]; then
+                       error "Copytool sent malformed event: $event"
+               fi
+               eval $parsed
+
+               if [ $event_type == "RESTORE_START" ]; then
+                       START_EVENT=$event
+                       if [ $source_fid != $data_fid ]; then
+                               error "source_fid should == data_fid at start"
+                       fi
+                       continue
+               elif [ $event_type == "RESTORE_FINISH" ]; then
+                       FINISH_EVENT=$event
+                       if [ $source_fid != $data_fid ]; then
+                               error "source_fid should == data_fid at finish"
+                       fi
+                       continue
+               elif [ $event_type != "RESTORE_RUNNING" ]; then
+                       continue
+               fi
+
+               # Do some simple checking of the progress update events.
+               for expected_field in $expected_fields; do
+                       if [ -z ${!expected_field+x} ]; then
+                               error "Missing $expected_field field in event"
+                       fi
+               done
+
+               if [ $total_bytes -eq 0 ]; then
+                       error "Expected total_bytes to be > 0"
+               fi
+
+               # When a restore starts out, the data fid is the same as the
+               # source fid. After the restore has gotten going, we learn
+               # the new data fid. Once the restore has finished, the source
+               # fid is set to the new data fid.
+               #
+               # We test this because some monitoring software may depend on
+               # this behavior. If it changes, then the consumers of these
+               # events may need to be modified.
+               if [ $source_fid == $data_fid ]; then
+                       error "source_fid should != data_fid during restore"
+               fi
+       done < <(echo $"$(get_copytool_event_log)")
+
+       if [ -z "$START_EVENT" ]; then
+               error "Copytool failed to send restore start event to FIFO"
+       fi
+
+       if [ -z "$FINISH_EVENT" ]; then
+               error "Copytool failed to send restore finish event to FIFO"
+       fi
+
+       echo "Restore events look OK."
+
+       cdt_clear_no_retry
+       copytool_cleanup
+       copytool_monitor_cleanup
+
+       rm -rf $test_dir
+}
+run_test 72 "Copytool logs JSON restore events to FIFO"
+
+test_90() {
+       file_count=51 # Max number of files constrained by LNET message size
+       mkdir $DIR/$tdir || error "mkdir $DIR/$tdir failed"
+       local f=$DIR/$tdir/$tfile
        local FILELIST=/tmp/filelist.txt
        local i=""
 
@@ -2214,7 +3115,14 @@ test_90() {
                fid=$(copy_file /etc/hosts $f.$i)
                echo $f.$i >> $FILELIST
        done
-       copytool_setup
+       # force copytool to use a local/temp archive dir to ensure best
+       # performance vs remote/NFS mounts used in auto-tests
+       if do_facet $SINGLEAGT "df --local $HSM_ARCHIVE" >/dev/null 2>&1 ; then
+               copytool_setup
+       else
+               local dai=$(get_hsm_param default_archive_id)
+               copytool_setup $SINGLEAGT $MOUNT $dai $TMP/$tdir
+       fi
        # to be sure wait_all_done will not be mislead by previous tests
        cdt_purge
        wait_for_grace_delay
@@ -2254,7 +3162,7 @@ double_verify_reset_hsm_param() {
 test_100() {
        double_verify_reset_hsm_param loop_period
        double_verify_reset_hsm_param grace_delay
-       double_verify_reset_hsm_param request_timeout
+       double_verify_reset_hsm_param active_request_timeout
        double_verify_reset_hsm_param max_requests
        double_verify_reset_hsm_param default_archive_id
 }
@@ -2284,7 +3192,7 @@ test_103() {
 
        echo "Current requests"
        local res=$(do_facet $SINGLEMDS "$LCTL get_param -n\
-                       $HSM_PARAM.agent_actions |\
+                       $HSM_PARAM.actions |\
                        grep -v CANCELED | grep -v SUCCEED | grep -v FAILED")
 
        [[ -z "$res" ]] || error "Some request have not been canceled"
@@ -2301,12 +3209,15 @@ test_104() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        # if cdt is on, it can serve too quickly the request
        cdt_disable
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER --data $DATA $f
        local data1=$(do_facet $SINGLEMDS "$LCTL get_param -n\
-                       $HSM_PARAM.agent_actions |\
+                       $HSM_PARAM.actions |\
                        grep $fid | cut -f16 -d=")
        cdt_enable
 
@@ -2327,12 +3238,12 @@ test_105() {
                $LFS hsm_archive $DIR/$tdir/$i
        done
        local reqcnt1=$(do_facet $SINGLEMDS "$LCTL get_param -n\
-                       $HSM_PARAM.agent_actions |\
+                       $HSM_PARAM.actions |\
                        grep WAITING | wc -l")
        cdt_restart
        cdt_disable
        local reqcnt2=$(do_facet $SINGLEMDS "$LCTL get_param -n\
-                       $HSM_PARAM.agent_actions |\
+                       $HSM_PARAM.actions |\
                        grep WAITING | wc -l")
        cdt_enable
        cdt_purge
@@ -2342,28 +3253,70 @@ test_105() {
 }
 run_test 105 "Restart of coordinator"
 
-test_106() {
-       # test needs a running copytool
-       copytool_setup
+get_agent_by_uuid_mdt() {
+       local uuid=$1
+       local mdtidx=$2
+       local mds=mds$(($mdtidx + 1))
+       do_facet $mds "$LCTL get_param -n ${MDT_PREFIX}${mdtidx}.hsm.agents |\
+                grep $uuid"
+}
+
+check_agent_registered_by_mdt() {
+       local uuid=$1
+       local mdtidx=$2
+       local mds=mds$(($mdtidx + 1))
+       local agent=$(get_agent_by_uuid_mdt $uuid $mdtidx)
+       if [[ ! -z "$agent" ]]; then
+               echo "found agent $agent on $mds"
+       else
+               error "uuid $uuid not found in agent list on $mds"
+       fi
+}
 
+check_agent_unregistered_by_mdt() {
+       local uuid=$1
+       local mdtidx=$2
+       local mds=mds$(($mdtidx + 1))
+       local agent=$(get_agent_by_uuid_mdt $uuid $mdtidx)
+       if [[ -z "$agent" ]]; then
+               echo "uuid not found in agent list on $mds"
+       else
+               error "uuid found in agent list on $mds: $agent"
+       fi
+}
+
+check_agent_registered() {
+       local uuid=$1
+       local mdsno
+       for mdsno in $(seq 1 $MDSCOUNT); do
+               check_agent_registered_by_mdt $uuid $((mdsno - 1))
+       done
+}
+
+check_agent_unregistered() {
+       local uuid=$1
+       local mdsno
+       for mdsno in $(seq 1 $MDSCOUNT); do
+               check_agent_unregistered_by_mdt $uuid $((mdsno - 1))
+       done
+}
+
+test_106() {
        local uuid=$(do_rpc_nodes $(facet_active_host $SINGLEAGT) \
                get_client_uuid $MOUNT | cut -d' ' -f2)
-       local agent=$(do_facet $SINGLEMDS $LCTL get_param -n $HSM_PARAM.agents |
-               grep $uuid)
+
+       copytool_setup
+       check_agent_registered $uuid
+
+       search_copytools || error "No copytool found"
+
        copytool_cleanup
-       [[ ! -z "$agent" ]] || error "My uuid $uuid not found in agent list"
-       local agent=$(do_facet $SINGLEMDS $LCTL get_param -n $HSM_PARAM.agents |
-               grep $uuid)
-       [[ -z "$agent" ]] ||
-               error "My uuid $uuid still found in agent list,"\
-                     " after copytool shutdown"
+       check_agent_unregistered $uuid
+
        copytool_setup
-       local agent=$(do_facet $SINGLEMDS $LCTL get_param -n $HSM_PARAM.agents |
-               grep $uuid)
+       check_agent_registered $uuid
+
        copytool_cleanup
-       [[ ! -z "$agent" ]] ||
-               error "My uuid $uuid not found in agent list after"\
-                     " copytool restart"
 }
 run_test 106 "Copytool register/unregister"
 
@@ -2570,7 +3523,10 @@ test_200() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_cancel $f)
+       local fid
+       fid=$(make_large_for_cancel $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        # test with cdt on is made in test_221
        cdt_disable
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
@@ -2611,7 +3567,10 @@ test_202() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
 
@@ -2639,7 +3598,7 @@ test_220() {
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
 
-       local flags=$(changelog_get_flags $MDT0 HSM $fid | tail -1)
+       local flags=$(changelog_get_flags ${MDT[0]} HSM $fid | tail -1)
        changelog_cleanup
 
        local target=0x0
@@ -2656,7 +3615,9 @@ test_221() {
        mkdir -p $DIR/$tdir
 
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_cancel $f)
+       local fid
+       fid=$(make_large_for_cancel $f)
+       [ $? != 0 ] && skip "not enough free space" && return
 
        changelog_setup
 
@@ -2666,7 +3627,7 @@ test_221() {
        wait_request_state $fid ARCHIVE CANCELED
        wait_request_state $fid CANCEL SUCCEED
 
-       local flags=$(changelog_get_flags $MDT0 HSM $fid | tail -1)
+       local flags=$(changelog_get_flags ${MDT[0]} HSM $fid | tail -1)
 
        local target=0x7d
        [[ $flags == $target ]] || error "Changelog flag is $flags not $target"
@@ -2691,7 +3652,7 @@ test_222a() {
        $LFS hsm_restore $f
        wait_request_state $fid RESTORE SUCCEED
 
-       local flags=$(changelog_get_flags $MDT0 HSM $fid | tail -1)
+       local flags=$(changelog_get_flags ${MDT[0]} HSM $fid | tail -1)
 
        local target=0x80
        [[ $flags == $target ]] || error "Changelog flag is $flags not $target"
@@ -2717,7 +3678,7 @@ test_222b() {
 
        wait_request_state $fid RESTORE SUCCEED
 
-       local flags=$(changelog_get_flags $MDT0 HSM $fid | tail -1)
+       local flags=$(changelog_get_flags ${MDT[0]} HSM $fid | tail -1)
 
        local target=0x80
        [[ $flags == $target ]] || error "Changelog flag is $flags not $target"
@@ -2746,7 +3707,7 @@ test_223a() {
        wait_request_state $fid RESTORE CANCELED
        wait_request_state $fid CANCEL SUCCEED
 
-       local flags=$(changelog_get_flags $MDT0 HSM $fid | tail -1)
+       local flags=$(changelog_get_flags ${MDT[0]} HSM $fid | tail -1)
 
        local target=0xfd
        [[ $flags == $target ]] ||
@@ -2763,7 +3724,9 @@ test_223b() {
        mkdir -p $DIR/$tdir
 
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
 
        changelog_setup
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
@@ -2775,7 +3738,7 @@ test_223b() {
        wait_request_state $fid RESTORE CANCELED
        wait_request_state $fid CANCEL SUCCEED
 
-       local flags=$(changelog_get_flags $MDT0 HSM $fid | tail -1)
+       local flags=$(changelog_get_flags ${MDT[0]} HSM $fid | tail -1)
 
        local target=0xfd
        [[ $flags == $target ]] ||
@@ -2801,7 +3764,7 @@ test_224() {
        $LFS hsm_remove $f
        wait_request_state $fid REMOVE SUCCEED
 
-       local flags=$(changelog_get_flags $MDT0 HSM $fid | tail -1)
+       local flags=$(changelog_get_flags ${MDT[0]} HSM $fid | tail -n 1)
 
        local target=0x200
        [[ $flags == $target ]] ||
@@ -2823,7 +3786,9 @@ test_225() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_progress $f)
+       local fid
+       fid=$(make_large_for_progress $f)
+       [ $? != 0 ] && skip "not enough free space" && return
 
        changelog_setup
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
@@ -2837,9 +3802,9 @@ test_225() {
        wait_request_state $fid REMOVE CANCELED
        wait_request_state $fid CANCEL SUCCEED
 
-       flags=$(changelog_get_flags $MDT0 RENME $fid2)
-       local flags=$($LFS changelog $MDT0 | grep HSM | grep $fid | tail -1 |
-               awk '{print $5}')
+       flags=$(changelog_get_flags ${MDT[0]} RENME $fid2)
+       local flags=$($LFS changelog ${MDT[0]} | grep HSM | grep $fid |
+               tail -n 1 | awk '{print $5}')
 
        local target=0x27d
        [[ $flags == $target ]] ||
@@ -2871,7 +3836,7 @@ test_226() {
 
        rm $f1 || error "rm $f1 failed"
 
-       local flags=$(changelog_get_flags $MDT0 UNLNK $fid1)
+       local flags=$(changelog_get_flags ${MDT[0]} UNLNK $fid1)
 
        local target=0x3
        [[ $flags == $target ]] ||
@@ -2879,7 +3844,7 @@ test_226() {
 
        mv $f3 $f2 || error "mv $f3 $f2 failed"
 
-       flags=$(changelog_get_flags $MDT0 RENME $fid2)
+       flags=$(changelog_get_flags ${MDT[0]} RENME $fid2)
 
        target=0x3
        [[ $flags == $target ]] ||
@@ -2899,7 +3864,7 @@ check_flags_changes() {
        local target=0x280
        $LFS hsm_set --$hsm_flag $f ||
                error "Cannot set $hsm_flag on $f"
-       local flags=($(changelog_get_flags $MDT0 HSM $fid))
+       local flags=($(changelog_get_flags ${MDT[0]} HSM $fid))
        local seen=${#flags[*]}
        cnt=$((fst + cnt))
        [[ $seen == $cnt ]] ||
@@ -2910,7 +3875,7 @@ check_flags_changes() {
 
        $LFS hsm_clear --$hsm_flag $f ||
                error "Cannot clear $hsm_flag on $f"
-       flags=($(changelog_get_flags $MDT0 HSM $fid))
+       flags=($(changelog_get_flags ${MDT[0]} HSM $fid))
        seen=${#flags[*]}
        cnt=$(($cnt + 1))
        [[ $cnt == $seen ]] ||
@@ -2950,10 +3915,9 @@ test_228() {
        # test needs a running copytool
        copytool_setup
 
-       dd if=/dev/urandom of=$DIR/$tfile bs=1M count=1 conv=sync ||
-               error "creating $DIR/$tfile"
+       local fid=$(make_small_sync $DIR/$tfile)
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $DIR/$tfile
-       wait_request_state $(path2fid $DIR/$tfile) ARCHIVE SUCCEED
+       wait_request_state $fid ARCHIVE SUCCEED
 
        $LFS hsm_release $DIR/$tfile
        check_hsm_flags $DIR/$tfile "0x0000000d"
@@ -2970,13 +3934,15 @@ test_228() {
        $LFS hsm_release $DIR/$tfile
        check_hsm_flags $DIR/$tfile "0x0000000d"
 
-       mkdir $DIR/$tdir
+       mkdir -p $DIR/$tdir || error "mkdir $tdir failed"
 
        tar cf - --sparse $DIR/$tfile | tar xvf - -C $DIR/$tdir ||
                error "tar failed"
        cmp $DIR/$tfile $DIR/$tdir/$DIR/$tfile ||
                error "comparing untarred $DIR/$tfile"
 
+       rm -f $DIR/$tfile $DIR/$tfile.2 ||
+               error "rm $DIR/$tfile or $DIR/$tfile.2 failed"
        copytool_cleanup
 }
 run_test 228 "On released file, return extend to FIEMAP. For [cp,tar] --sparse"
@@ -3005,12 +3971,12 @@ test_250() {
        while [[ $cnt != 0 || $wt != 0 ]]; do
                sleep 1
                cnt=$(do_facet $SINGLEMDS "$LCTL get_param -n\
-                       $HSM_PARAM.agent_actions |\
+                       $HSM_PARAM.actions |\
                        grep STARTED | grep -v CANCEL | wc -l")
                [[ $cnt -le $maxrequest ]] ||
                        error "$cnt > $maxrequest too many started requests"
                wt=$(do_facet $SINGLEMDS "$LCTL get_param\
-                       $HSM_PARAM.agent_actions |\
+                       $HSM_PARAM.actions |\
                        grep WAITING | wc -l")
                echo "max=$maxrequest started=$cnt waiting=$wt"
        done
@@ -3025,24 +3991,30 @@ test_251() {
 
        mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
-       local fid=$(make_large_for_cancel $f)
+       local fid
+       fid=$(make_large_for_cancel $f)
+       [ $? != 0 ] && skip "not enough free space" && return
 
        cdt_disable
        # to have a short test
-       local old_to=$(get_hsm_param request_timeout)
-       set_hsm_param request_timeout 4
+       local old_to=$(get_hsm_param active_request_timeout)
+       set_hsm_param active_request_timeout 4
        # to be sure the cdt will wake up frequently so
        # it will be able to cancel the "old" request
        local old_loop=$(get_hsm_param loop_period)
        set_hsm_param loop_period 2
        cdt_enable
 
+       # clear locks to avoid extra delay caused by flush/cancel
+       # and thus prevent early copytool death to timeout.
+       cancel_lru_locks osc
+
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE STARTED
        sleep 5
        wait_request_state $fid ARCHIVE CANCELED
 
-       set_hsm_param request_timeout $old_to
+       set_hsm_param active_request_timeout $old_to
        set_hsm_param loop_period $old_loop
 
        copytool_cleanup
@@ -3099,7 +4071,11 @@ test_302() {
        cdt_shutdown
 
        set_hsm_param default_archive_id $new -P
-       fail $SINGLEMDS
+
+       local mdtno
+       for mdtno in $(seq 1 $MDSCOUNT); do
+               fail mds${mdtno}
+       done
 
        # check cdt is on
        cdt_check_state enabled
@@ -3113,6 +4089,231 @@ test_302() {
 }
 run_test 302 "HSM tunnable are persistent when CDT is off"
 
+test_400() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+
+       local dir_mdt0=$DIR/$tdir/mdt0
+       local dir_mdt1=$DIR/$tdir/mdt1
+
+       # create 1 dir per MDT
+       $LFS mkdir -i 0 $dir_mdt0 || error "lfs mkdir"
+       $LFS mkdir -i 1 $dir_mdt1 || error "lfs mkdir"
+
+       # create 1 file in each MDT
+       local fid1=$(make_small $dir_mdt0/$tfile)
+       local fid2=$(make_small $dir_mdt1/$tfile)
+
+       # check that hsm request on mdt0 is sent to the right MDS
+       $LFS hsm_archive $dir_mdt0/$tfile || error "lfs hsm_archive"
+       wait_request_state $fid1 ARCHIVE SUCCEED 0 &&
+               echo "archive successful on mdt0"
+
+       # check that hsm request on mdt1 is sent to the right MDS
+       $LFS hsm_archive $dir_mdt1/$tfile || error "lfs hsm_archive"
+       wait_request_state $fid2 ARCHIVE SUCCEED 1 &&
+               echo "archive successful on mdt1"
+
+       copytool_cleanup
+       # clean test files and directories
+       rm -rf $dir_mdt0 $dir_mdt1
+}
+run_test 400 "Single request is sent to the right MDT"
+
+test_401() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+
+       local dir_mdt0=$DIR/$tdir/mdt0
+       local dir_mdt1=$DIR/$tdir/mdt1
+
+       # create 1 dir per MDT
+       $LFS mkdir -i 0 $dir_mdt0 || error "lfs mkdir"
+       $LFS mkdir -i 1 $dir_mdt1 || error "lfs mkdir"
+
+       # create 1 file in each MDT
+       local fid1=$(make_small $dir_mdt0/$tfile)
+       local fid2=$(make_small $dir_mdt1/$tfile)
+
+       # check that compound requests are shunt to the rights MDTs
+       $LFS hsm_archive $dir_mdt0/$tfile $dir_mdt1/$tfile ||
+               error "lfs hsm_archive"
+       wait_request_state $fid1 ARCHIVE SUCCEED 0 &&
+               echo "archive successful on mdt0"
+       wait_request_state $fid2 ARCHIVE SUCCEED 1 &&
+               echo "archive successful on mdt1"
+
+       copytool_cleanup
+       # clean test files and directories
+       rm -rf $dir_mdt0 $dir_mdt1
+}
+run_test 401 "Compound requests split and sent to their respective MDTs"
+
+mdc_change_state() # facet, MDT_pattern, activate|deactivate
+{
+       local facet=$1
+       local pattern="$2"
+       local state=$3
+       local node=$(facet_active_host $facet)
+       local mdc
+       for mdc in $(do_facet $facet "$LCTL dl | grep -E ${pattern}-mdc" |
+                       awk '{print $4}'); do
+               echo "$3 $mdc on $node"
+               do_facet $facet "$LCTL --device $mdc $state" || return 1
+       done
+}
+
+test_402() {
+       # make sure there is no running copytool
+       copytool_cleanup
+
+       # deactivate all mdc on agent1
+       mdc_change_state $SINGLEAGT "$FSNAME-MDT000." "deactivate"
+
+       HSMTOOL_NOERROR=true copytool_setup $SINGLEAGT
+
+       check_agent_unregistered "uuid" # match any agent
+
+       # no expected running copytool
+       search_copytools $agent && error "Copytool start should have failed"
+
+       # reactivate MDCs
+       mdc_change_state $SINGLEAGT "$FSNAME-MDT000." "activate"
+}
+run_test 402 "Copytool start fails if all MDTs are inactive"
+
+test_403() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+
+       # make sure there is no running copytool
+       copytool_cleanup
+
+        local agent=$(facet_active_host $SINGLEAGT)
+       local uuid=$(do_rpc_nodes $agent get_client_uuid | cut -d' ' -f2)
+
+       # deactivate all mdc for MDT0001
+       mdc_change_state $SINGLEAGT "$FSNAME-MDT0001" "deactivate"
+
+       copytool_setup
+       # check the agent is registered on MDT0000, and not on MDT0001
+       check_agent_registered_by_mdt $uuid 0
+       check_agent_unregistered_by_mdt $uuid 1
+
+       # check running copytool process
+       search_copytools $agent || error "No running copytools on $agent"
+
+       # reactivate all mdc for MDT0001
+       mdc_change_state $SINGLEAGT "$FSNAME-MDT0001" "activate"
+
+       # make sure the copytool is now registered to all MDTs
+       check_agent_registered $uuid
+
+       copytool_cleanup
+}
+run_test 403 "Copytool starts with inactive MDT and register on reconnect"
+
+test_404() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+
+       copytool_setup
+
+       # create files on both MDT0000 and MDT0001
+       mkdir -p $DIR/$tdir
+
+       local dir_mdt0=$DIR/$tdir/mdt0
+       $LFS mkdir -i 0 $dir_mdt0 || error "lfs mkdir"
+
+       # create 1 file on mdt0
+       local fid1=$(make_small $dir_mdt0/$tfile)
+
+       # deactivate all mdc for MDT0001
+       mdc_change_state $SINGLEAGT "$FSNAME-MDT0001" "deactivate"
+
+       # send an HSM request for files in MDT0000
+       $LFS hsm_archive $dir_mdt0/$tfile || error "lfs hsm_archive"
+
+       # check for completion of files in MDT0000
+       wait_request_state $fid1 ARCHIVE SUCCEED 0 &&
+               echo "archive successful on mdt0"
+
+       # reactivate all mdc for MDT0001
+       mdc_change_state $SINGLEAGT "$FSNAME-MDT0001" "activate"
+
+       copytool_cleanup
+       # clean test files and directories
+       rm -rf $dir_mdt0
+}
+run_test 404 "Inactive MDT does not block requests for active MDTs"
+
+test_405() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+
+       local striped_dir=$DIR/$tdir/striped_dir
+
+       # create striped dir on all of MDTs
+       $LFS mkdir -i 0 -c $MDSCOUNT $striped_dir || error "lfs mkdir"
+
+       local fid1=$(make_small_sync $striped_dir/${tfile}_0)
+       local fid2=$(make_small_sync $striped_dir/${tfile}_1)
+       local fid3=$(make_small_sync $striped_dir/${tfile}_2)
+       local fid4=$(make_small_sync $striped_dir/${tfile}_3)
+
+       local idx1=$($LFS getstripe -M $striped_dir/${tfile}_0)
+       local idx2=$($LFS getstripe -M $striped_dir/${tfile}_1)
+       local idx3=$($LFS getstripe -M $striped_dir/${tfile}_2)
+       local idx4=$($LFS getstripe -M $striped_dir/${tfile}_3)
+
+       # check that compound requests are shunt to the rights MDTs
+       $LFS hsm_archive $striped_dir/${tfile}_0 $striped_dir/${tfile}_1  \
+                        $striped_dir/${tfile}_2 $striped_dir/${tfile}_3 ||
+               error "lfs hsm_archive"
+
+       wait_request_state $fid1 ARCHIVE SUCCEED $idx1 &&
+               echo "archive successful on $fid1"
+       wait_request_state $fid2 ARCHIVE SUCCEED $idx2 &&
+               echo "archive successful on $fid2"
+       wait_request_state $fid3 ARCHIVE SUCCEED $idx3 &&
+               echo "archive successful on $fid3"
+       wait_request_state $fid4 ARCHIVE SUCCEED $idx4 &&
+               echo "archive successful on $fid4"
+
+       $LFS hsm_release $striped_dir/${tfile}_0 || error "lfs hsm_release 1"
+       $LFS hsm_release $striped_dir/${tfile}_1 || error "lfs hsm_release 2"
+       $LFS hsm_release $striped_dir/${tfile}_2 || error "lfs hsm_release 3"
+       $LFS hsm_release $striped_dir/${tfile}_3 || error "lfs hsm_release 4"
+
+       cat $striped_dir/${tfile}_0 > /dev/null || error "cat ${tfile}_0 failed"
+       cat $striped_dir/${tfile}_1 > /dev/null || error "cat ${tfile}_1 failed"
+       cat $striped_dir/${tfile}_2 > /dev/null || error "cat ${tfile}_2 failed"
+       cat $striped_dir/${tfile}_3 > /dev/null || error "cat ${tfile}_3 failed"
+
+       copytool_cleanup
+}
+run_test 405 "archive and release under striped directory"
+
+test_500()
+{
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.6.92) ] &&
+               skip "HSM migrate is not supported" && return
+
+       # Stop the existing copytool
+       copytool_cleanup
+
+       test_mkdir -p $DIR/$tdir
+       llapi_hsm_test -d $DIR/$tdir || error "One llapi HSM test failed"
+}
+run_test 500 "various LLAPI HSM tests"
+
 copytool_cleanup
 
 complete $SECONDS